<?php

namespace App\DAO;

use App\DAO\DAOResponse\DAOResponse;
use App\DAO\DAOResponse\DAOResponseInterface;
use App\DAO\Pagination\Pagination;
use App\Entities\Especialidade\Especialidade;
use App\Mappers\EspecialidadeMapper;
use App\Models\EspecialidadeModel;
use App\Services\LogService;
use App\Utils\Collections\QueryFilterCollection;
use App\Utils\Collections\QueryOrderCollection;
use App\ViewModels\Especialidade\EspecialidadeRegistrationViewModel\EspecialidadeRegistrationViewModel;
use App\ViewModels\Especialidade\EspecialidadeUpdateViewModel\EspecialidadeUpdateViewModel;
use Exception;

class EspecialidadeDAO extends DAO {

	public function persistEspecialidadeRegistrationVM(EspecialidadeRegistrationViewModel $especialidade_registration_vm): DAOResponse {

		try {
			$especialidade = $this->persistEspecialidade( $especialidade_registration_vm );
			$error = $this->db->error();
			if ($error && $error ['code']) {
				$status_persistence = $error ['code'];
			} else {
				$status_persistence = !!$especialidade->getId() ? DAOResponseInterface::SUCESS : DAOResponseInterface::DATABASE_CONNECTION_ERROR;
			}
		} catch ( Exception $exception ) {
			log_message( 'error', json_encode( $this->db->error() ) );
			$status_persistence = DAOResponseInterface::DATABASE_CONNECTION_ERROR;
			$especialidade = null;
		}
		$this->db->close();
		$dao_response = DAOResponse::builder()->setStatus( $status_persistence )
			->build();
		if ($status_persistence === DAOResponseInterface::SUCESS) {
			$dao_response->setData( $especialidade );
		}
		return $dao_response;

	}

	public function getEspecialidadeList(?Pagination $pagination, ?QueryFilterCollection $query_filter_collection,
			?QueryOrderCollection $query_order_collection = null): DAOResponse {

		$sql = '
            SELECT 
                id,
                descricao 
            FROM especialidade
        ';
		return $this->getDAOResponseFromPaginatedSelect( [ ], $pagination, $query_filter_collection, $query_order_collection, $sql,
			function (array $result_array) {
				return EspecialidadeMapper::getEspecialidadeDetailsVMCollectionFromArray( $result_array );
			} );

	}

	public function deleteEspecialidade(int $id_procedimento): DAOResponse {

		$especialidade_model = new EspecialidadeModel();
		$dao_response = $this->getDAOResponseForDeletion( $especialidade_model, $id_procedimento );
		return $dao_response;

	}

	private function persistEspecialidade(EspecialidadeRegistrationViewModel $especialidade_registration_vm): Especialidade {

		$especialidade_model = new EspecialidadeModel();
		$especialidade = EspecialidadeMapper::getEspecialidadeFromEspecialidadeRegistrationViewModel( $especialidade_registration_vm );
		$especialidade_model->registerEspecialidade( $especialidade );
		return $especialidade;

	}

	public function getEspecialidade(QueryFilterCollection $query_filter_collection): DAOResponse {

		$sql = '
            SELECT
                especialidade.id AS id,
                especialidade.descricao AS descricao
            FROM
                especialidade
        ';
		$binds = [ ];
		return $this->getDAOResponseFromUniqueRowSelect( $binds, $query_filter_collection, $sql,
			function (array $result_array) {
				return EspecialidadeMapper::getEspecialidadeDetailsVMFromArray( $result_array [0] );
			} );

	}

	public function persistEspecialidadeUpdateVM(int $id_procedimento, EspecialidadeUpdateViewModel $especie_update_vm): DAOResponse {

		$status_persistence = $this->persistEspecialidadeFromEspecialidadeUpdateVM( $id_procedimento, $especie_update_vm );
		$error = $this->db->error();
		$this->db->close();
		$dao_response = new DAOResponse();
		if ($error && $error ['code']) {
			$status_response = $error ['code'];
			$dao_response_errors = [ ];
			$dao_response->setErrors( $dao_response_errors );
			(new LogService())->log_error( $status_response, "Ocorreu um erro durante a atualização do procedimento $id_procedimento",
				$especie_update_vm->toArray() );
		} else {
			$status_response = $status_persistence ? DAOResponseInterface::SUCESS : DAOResponseInterface::RECORD_NOT_FOUND;
		}
		$dao_response->setStatus( $status_response );
		return $dao_response;

	}

	private function persistEspecialidadeFromEspecialidadeUpdateVM(int $id_procedimento, EspecialidadeUpdateViewModel $especie_update_vm): bool {

		$especie_model = new EspecialidadeModel();
		$especie = EspecialidadeMapper::getEspecialidadeFromEspecialidadeUpdateVM( $especie_update_vm );
		$sucess_update = $especie_model->updateEspecialidadeByID( $id_procedimento, $especie );
		return $sucess_update;

	}

	public function getEspecialidadeListByUnidadeId(int $id_unidade): DAOResponse {

		$dao_response = new DAOResponse();
		$sql = <<<SQL
			select distinct ep.id_especialidade , e.descricao
			from especialidade e , especialidade_procedimento ep
			where ep.id_unidade = :id_unidade: and ep.id_especialidade = e.id 
		SQL;

		$binds = [ 
			'id_unidade' => $id_unidade ];

		$conn = db_connect();
		$result = $conn->query( $sql, $binds )
			->getResultArray();
		$errors = $conn->error();

		if ($errors ['code'] != 0) {
			$dao_response->setErrors( $errors );
			$dao_response->setStatus( DAOResponseInterface::DATABASE_CONNECTION_ERROR );
		} else {
			$dao_response->setStatus( DAOResponseInterface::SUCESS );
			$dao_response->setData( $result );
		}
		return $dao_response;

	}

}